package sample;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.ffc.gkit.excelgenerator.EGBook;
import jp.co.ffc.gkit.excelgenerator.EGRange;
import jp.co.ffc.gkit.excelgenerator.EGSheet;

import org.apache.commons.fileupload.DiskFileUpload;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUploadException;

public class Sample04 extends HttpServlet {

	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {

		//Abv[hꂽt@CInputStream擾
		InputStream is = null;
		DiskFileUpload objDfu = new DiskFileUpload();
		objDfu.setSizeMax(-1);
		objDfu.setSizeThreshold(1024);
		objDfu.setHeaderEncoding("Shift_JIS");
		try {
			List objLst = objDfu.parseRequest(request);
			Iterator objItr = objLst.iterator();
			while (objItr.hasNext()) {
				FileItem objFi = (FileItem) objItr.next();
				if (!objFi.isFormField()) {
					is = objFi.getInputStream();
					break;
				}
			}
		} catch (FileUploadException e) {
			e.printStackTrace();
		}
		
		response.setContentType("text/html; charset=Shift_JIS");
		PrintWriter out = response.getWriter();
		out.println("<html>");
		out.println("<body>");
		out.println("<h2>Abv[hGNZt@C̓e</h2>");
		
		//f[^擾
		if (is != null) {
			EGBook book;
			try {
				book = new EGBook(is);
			} catch (RuntimeException e) {
				out.println("Abv[hꂽGNZt@C͓Ǎ߂܂");
				return;
			}
			EGSheet sheet = book.getSheetAt(0);
			EGRange header = sheet.getHeaderRange();
			
			// V[g̎擾
			String sheetName = book.getSheetName(0);
			out.println("<H1>" + sheetName + "</H1>");
			
			out.println("<table border='1'>");
			
			for (int row = 0; row < header.getLastRowNum(); row++) {
				
				out.print("<tr>");
				out.print("<td>"+row+"</td>");
				for (int col = 0; col < header.getLastCellNum(row); col++) {
					
					out.print("<td>");
					
					Short type = header.getType(row, col);
					if(type==null){
						out.print("<br>");
						break;
					}
					out.print("[" + row + ":" + col + "]");
					switch (type.shortValue()) {
					case EGRange.CELL_TYPE_BLANK:
						out.print("BLANK");
						break;
					case EGRange.CELL_TYPE_BOOLEAN:
						out.print("BOOLEAN:");
						out.print(header.getDataBoolean(row, col));
						break;
					case EGRange.CELL_TYPE_NUMERIC:
						out.print("NUMERIC:");
						out.print(header.getDataNumeric(row, col));
						break;
					case EGRange.CELL_TYPE_STRING:
						out.print("STRING:");
						out.print(header.getDataString(row, col));
						break;
					case EGRange.CELL_TYPE_FORMULA:
						out.print("FORMULA:");
						out.print(header.getFormula(row, col));
						break;
					}
					
					out.print("</td>");
				}
				out.println("</tr>");
			}
			out.println("</table>");
		}

		out.println("</body>");
		out.println("</html>");
		
	}

}
